; Requires Lee Mac's QuickField
; http://www.lee-mac.com/quickfield.html
; (load "QuickFieldV1-3.lsp")

(defun c:FCS ( / idx ssol solEnt solCentroid solVolSum QF scalefactor)
	(setq scalefactor (/ 1.0 (getvar 'cannoscalevalue))) ; set scalefactor to use with objects
	
	(acet-error-init '(nil 1 nil)) ; set error handler, undo on error, no special cleanup
	; save and set system vars.
	(acet-sysvar-set (list "CMDECHO" 0 "OSMODE" 0 "TEXTSIZE" (* (getvar "TEXTSIZE") scalefactor)))
  ; define locally the Lee-Mac function as a command !        
  (defun c:QF () (LM:QuickField "Volume" "%lu2%ps[VOLUME: ,]" 3))

  ; create a selection set of 3D solids...
  (prompt "Select 3D Solids \n")
  (setq ssol (ssget '((0 . "3DSOLID")))
        idx   0   ;set the index to the first entity in the selection set
        solVolSum 0
        ) 

  ;loop through the selection set.....>
  (while (< idx (sslength ssol))

      ; get the 3D solid entity and its Centroid 
      (setq solEnt       (ssname ssol idx)            ;select the solid 
            solCentroid  (vlax-get (vlax-ename->vla-object solEnt) 'Centroid)  ;find its centroid
            solVol       (vlax-get (vlax-ename->vla-object solEnt) 'Volume)         ;find its volume
      )

      ; Draw the SPHERE at Centroid....
      (vl-cmdf "_SPHERE" "_non" solCentroid (* 1.0 scalefactor))

      ;call the QF command with the 2 arguments !
      (vl-cmdf "QF" solEnt solCentroid)

      (setq idx       (1+ idx)      ;get next solid in the selection set...
            solVolSum (+ solVolSum solVol) ;add to the SUM of volumes
      )
  )
  (acet-sysvar-restore)
  (acet-error-restore) ; restore environment
  (prompt "\n")
  solVolSum
)